#pragma once
#include "Environ.h"

//		Chisel Class defaults : use "dirty white", no black border, chisel "in" when Chisel called
enum	chiselFlags { chiselDefaults=-1, dirtyWhite=2, noBlackBorder=4, chiselIn=8 };

class	ChiselClass {

	RGBColor	liteChisel, darkChisel, darkGrey, myWhite, myBlack, myDirtyWhite;
	Boolean		useRGB, addBlackBorder, chiselWay, useDefaultRect;
	short		borderWidth, blackWidth;
	Rect		dRect;
	void		Chisel(Rect theRect, Boolean out);
	void		HairChisel(Rect &theRect, Boolean out);
	void		InitializeVars(short options);
	
	int		GetHi(RGBColor &color);
	int		GetLo(RGBColor &color);
	
	int		kColorPress, kMinColor, kMaxColor;
	
public:

	ChiselClass(short options=chiselDefaults);
	ChiselClass(Rect defaultRect, short options=chiselDefaults);
	
	void	Chisel();						//	Chisel the default rect in default ways
	
	void	Chisel(Rect theRect);			//	Chisel theRect in default ways
	void	ChiselOut(Rect theRect);		//	Chisel (out) theRect
	void	ChiselIn(Rect theRect);			//	Chisel (in) theRect
	
	void	HairChisel();					//	Produces a hairline chisel effect with default rect
	
	void	HairChisel(Rect theRect);		//	Hairline chisel theRect in default ways
	void	HairChiselOut(Rect theRect);	//	Hairline chisel out (black on left and top)
	void	HairChiselIn(Rect theRect);		//	Hairline chisel in	(black on right and bottom)
	
	Rect	ChiselRect(Rect theRect);		//	Passed a Rect, returns chisel rect of that Rect
	Rect	ChiselRect();					//	Returns default chisel Rect
	Rect	PreChisel(Rect theRect);		//	Returns the original rect needed to obtain a chisel
											//	rect the size of theRect passed
	Rect	PreChisel();

	void	CleanRect();					//	Erases the default rect ChiselIn/Out would create
	void	CleanRect(Rect theRect);		//	Erases the rectangle ChiselIn/Out would create

	void	InvalChisel();					//	Invalidates default rect ChiselIn/Out would create
	void	InvalChisel(Rect theRect);		//	Invalidates rect ChiselIn/Out would create
	
	void	SetDefaultRect(Rect &theRect);					//	Set default rect
	void	SetOptions(short options=chiselDefaults);		//	Set options (if you can't when declaring the var)
	void	SetChiselWay(short chiselDir);					//	Set default chisel direction (use
															//	chiselIn or !chiselIn)

	void	SetChiselWidth(short width);		//	Set width of chisel, in pixels, default is 3
												//	Note: This automatically sets black border
												//	width to half this value
												
	void	SetBlackBorderWidth(short width);	//	Set width of black border inside chisel,
												//	automatically half of chisel width, unless
												//	overridden here

	void	SetDarkChiselColor(RGBColor darkColor);	//	dark chisel color
	void	SetLiteChiselColor(RGBColor	liteColor);	//	lite chisel color
	void	SetFrameColor(RGBColor frameColor);		//	black border color
	void	LiteDarkFrom(RGBColor baseColor);		//	gets the light and dark shades from the
													//	base color and sets them to the light and
													//	dark components of the chisel class

	void	LiteFrom(RGBColor baseColor);			//	sets the light component from baseColor
	void	DarkFrom(RGBColor baseColor);			//	sets the dark component from baseColor
	
	void	UseDirtyWhite(Boolean dirty);			//	Toggle the use of a dirty over a pure white
													//	in the edging
													
	void	UseBlackFrame(Boolean useBlackBorder);
};


